using System;
using System.Drawing;
using System.Windows.Forms;

namespace TestProject;

/// <summary>
///  
/// </summary>
public partial class MainForm : Form
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region  - MainForm()

    /// <summary>
    /// 
    /// </summary>
    public MainForm()
    {
        InitializeComponent();

        float[]  levelArray = { 0f, 0.2f, 0.4f, 0.6f, 0.8f, 1f };
        Color[]  colorArray = { Color.Blue, Color.Green, Color.Yellow, Color.Orange, Color.Red };
        float[,] valueArray = GetValueArray();

        contourChartControl.SetData(levelArray, colorArray, valueArray);
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Private

    #region  迭 ϱ - GetValueArray()

    /// <summary>
    ///  迭 ϱ
    /// </summary>
    /// <returns> 迭</returns>
    public float[,] GetValueArray()
    {
        int width  = this.contourChartControl.Width;
        int height = this.contourChartControl.Height;

        float[,] valueArray = new float[width, height];

        for(int x = 0; x < width; x++)
        {
            for(int y = 0; y < height; y++)
            {
                float xNormalized = (float)x / width  * 10;
                float yNormalized = (float)y / height * 10;

                valueArray[x, y] = (float)(Math.Sin(xNormalized) * Math.Cos(yNormalized) + Math.Cos(xNormalized * 0.5f) * Math.Sin(yNormalized * 0.5f));
            
                valueArray[x, y] = (valueArray[x, y] + 1) / 2;
            }
        }

        return valueArray;
    }

    #endregion
}